Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.net.ssl
Class SSLServerSocket

    java.lang.Object
      |
      +--java.net.ServerSocket
            |
            +--javax.net.ssl.SSLServerSocket

public abstract class SSLServerSocket
extends ServerSocket

This class is extended by server sockets which return connections which are protected using the Secure Sockets Layer (SSL) protocol, and which extend the SSLSocket class.

Constructor Summary
`protected` | `SSLServerSocket(int port)` Used only by subclasses.
`protected` | `SSLServerSocket(int port, int backlog)` Used only by subclasses.
`protected` | `SSLServerSocket(int port, int backlog, InetAddress address)` Used only by subclasses.

Method Summary
`abstract String[]` | `getEnabledCipherSuites()` Returns the list of cipher suites which are currently enabled for use by newly accepted connections.
`abstract boolean` | `getEnableSessionCreation()` Returns true if new SSL sessions may be established by the sockets which are created from this server socket.
`abstract boolean` | `getNeedClientAuth()` Returns true if client authentication is required on newly accepted connections.
`abstract String[]` | `getSupportedCipherSuites()` Returns the names of the cipher suites which could be enabled for use on an SSL connection.
`abstract boolean` | `getUseClientMode()` Returns true if accepted connections will be in SSL client mode.
`abstract void` | `setEnabledCipherSuites(String[] suites)` Controls which particular SSL cipher suites are enabled for use by accepted connections.
`abstract void` | `setEnableSessionCreation(boolean flag)` Returns true if new SSL sessions may be established by the sockets which are created from this server socket.
`abstract void` | `setNeedClientAuth(boolean flag)` Controls whether the connections which are accepted must include client authentication.
`abstract void` | `setUseClientMode(boolean mode)` Controls whether accepted connections are in the (default) SSL server mode, or the SSL client mode.

Methods inherited from class java.net.ServerSocket
`accept, close, getInetAddress, getLocalPort, getSoTimeout, implAccept, setSocketFactory, setSoTimeout, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SSLServerSocket

    protected SSLServerSocket(int port)
                       throws IOException

  Used only by subclasses. Create a TCP server socket on a port, using the default authentication context. The connection backlog defaults to fifty connections queued up before the system starts to reject new connection requests.
  Parameters:
    `port` - the port on which to listen

### SSLServerSocket

    protected SSLServerSocket(int port,
                              int backlog)
                       throws IOException

  Used only by subclasses. Create a TCP server socket on a port, using the default authentication context and a specified backlog of connections.
  Parameters:
    `port` - the port on which to listen
    `backlog` - how many connections may be pending before the system should start rejecting new requests

### SSLServerSocket

    protected SSLServerSocket(int port,
                              int backlog,
                              InetAddress address)
                       throws IOException

  Used only by subclasses. Create a TCP server socket on a port, using the default authentication context and a specified backlog of connections as well as a particular specified network interface. This constructor is used on multihomed hosts, such as those used for firewalls or as routers, to control through which interface a network service is provided.
  Parameters:
    `port` - the port on which to listen
    `backlog` - how many connections may be pending before the system should start rejecting new requests
    `address` - the address of the network interface through which connections will be accepted

Method Detail

### getSupportedCipherSuites

    public abstract String[] getSupportedCipherSuites()

  Returns the names of the cipher suites which could be enabled for use on an SSL connection. Normally, only a subset of these will actually be enabled by default, since this list may include cipher suites which do not meet quality of service requirements for those defaults. Such cipher suites are useful in specialized applications.
  Returns:
    an array of cipher suite names

### getEnabledCipherSuites

    public abstract String[] getEnabledCipherSuites()

  Returns the list of cipher suites which are currently enabled for use by newly accepted connections. If this has not been explicitly modified, a system-provided default guarantees a minimum quality of service in all enabled cipher suites. That default is accessible through the SSLSocket API.

  There are several reasons why an enabled cipher suite might not actually be used. For example: the server socket might not have appropriate private keys available to it or the cipher suite might be anonymous, precluding the use of client authentication, while the server socket has been told to require that sort of authentication.

  Returns:
    an array of cipher suite names

### setEnabledCipherSuites

    public abstract void setEnabledCipherSuites(String[] suites)

  Controls which particular SSL cipher suites are enabled for use by accepted connections. The cipher suites must have been listed by getSupportedCipherSuites() as being supported. Suites which require authentication information which is not available in this ServerSocket's authentication context will not be used in any case, even if they are enabled.
  Parameters:
    `suites` - Names of all the cipher suites to enable; null means to accept system defaults.

### setUseClientMode

    public abstract void setUseClientMode(boolean mode)

  Controls whether accepted connections are in the (default) SSL server mode, or the SSL client mode. In rare cases, TCP servers need to act in the SSL client mode on newly accepted connections in order to reuse sessions. For example, FTP clients acquire server sockets and listen there for reverse connections, from the server. FTP clients would use SSLServerSockets in "client" mode, in order to reuse existing SSL sessions where the FTP client is acting as a client.
  Parameters:
    `flag` - true if newly accepted connections should use SSL client mode.

### getUseClientMode

    public abstract boolean getUseClientMode()

  Returns true if accepted connections will be in SSL client mode.
  Returns:
    true if the connection should use SSL client mode.

### setNeedClientAuth

    public abstract void setNeedClientAuth(boolean flag)

  Controls whether the connections which are accepted must include client authentication. By default, clients do not need to provide authentication information. This control requires the connection to be in the (default) SSL server mode.
  Parameters:
    `flag` - true if the clients must authenticate themselves.

### getNeedClientAuth

    public abstract boolean getNeedClientAuth()

  Returns true if client authentication is required on newly accepted connections.
  Returns:
    true if the clients must authenticate themselves.

### setEnableSessionCreation

    public abstract void setEnableSessionCreation(boolean flag)

  Returns true if new SSL sessions may be established by the sockets which are created from this server socket.
  Parameters:
    `flag` - true indicates that sessions may be created; this is the default. false indicates that an existing session must be resumed.

### getEnableSessionCreation

    public abstract boolean getEnableSessionCreation()

  Returns true if new SSL sessions may be established by the sockets which are created from this server socket.
  Returns:
    true indicates that sessions may be created; this is the default. false indicates that an existing session must be resumed.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD